Subject: [mobile-ip] Question on RFC 3220 - Agent Advertisement messages in Manets

From: "Phil Neumiller" <[email-masked]>
Date: Wed, 29 May 2002 15:05:36 -0400

Charlie,

Suppose one wishes to use MIP with a MANET.  Futhermore, suppose one performs an agent advertisement
solicitation.  This will normally result in a specially formatted route advertisment which would work fine provided
you had an actual subnet!  In the case of a mesh or MANET with no local topologically correct prefixing the 
only solution is to have all nodes flood these advertisements over the entire MANET network right?  Yuck!
Why couldn't the Agent Advertisement be optionally unicast back to the solicitor MN.

Thanks,

Phil

--
Phillip D. Neumiller ([email-masked])
My PGP key can be imported from the following URL:
http://pgpkeys.mit.edu

---

From: "Phil Neumiller" <[email-masked]>
Date: Thu, 30 May 2002 09:12:40 -0400

Charlie,

I found this in RFC 3220

---

From: "Phil Neumiller" <[email-masked]>
Date: Thu, 30 May 2002 09:15:09 -0400

Charlie,

I think I was confused in my previous mail.  I found the following in RFC 3220 in the Agent
 Advertisemetn section.

               The link-layer destination address of a unicast Agent

               Advertisement MUST be the same as the source link-layer

               address of the Agent Solicitation which prompted the

               Advertisement.

Does this mean that soliciations will always be answered with unicast 

advertisements?  When I read the ICMP route advertisement RFC

it indicated only multi-cast and subnet broadcast destinations addresses.

Is there something in the MIP implementation in the HAs and FAs that

knows to send unicast back to solicitations?

Thanks,

Phil

---

From: "Phil Neumiller" <[email-masked]>
Date: Thu, 30 May 2002 09:23:05 -0400

I am not sure I understand the TTL = 1 thing in agent soliciation messages.  In a multi-hop
network, the only choice seems to propagate the subnet masks of HA/FA to all mobiles
in the subnet if DHCP is used and proxy response to the solicitor with HA/FA subnet
mask right?

---

From: "Charles E. Perkins" <[email-masked]>
Date: Thu, 30 May 2002 09:28:07 -0700

Hello Phil,

Phil Neumiller wrote:

> I am not sure I understand the TTL = 1 thing in agent soliciation messages.
> In a multi-hop  network, the only choice seems to propagate the subnet masks
> of HA/FA to all mobiles in the subnet if DHCP is used and proxy response to
> the solicitor with HA/FA subnet mask right?

The original motivation for the restriction was to avoid martian
invaders.  For attaching an ad hoc network to a foreign agent, it
makes sense to rescind the restriction, and in fact we have specified
that in our drafts to the [manet] working group related to this point.

Regards,
Charlie P.

---

From: "Charles E. Perkins" <[email-masked]>
Date: Thu, 30 May 2002 10:20:22 -0700

Hello Phil,

Phil Neumiller wrote:

> Suppose one wishes to use MIP with a MANET.  Futhermore, suppose one
> performs an agent advertisement solicitation.  This will normally result
> in a specially formatted route advertisment which would work fine provided
> you had an actual subnet!  In the case of a mesh or MANET with no local
> topologically correct prefixing the only solution is to have all nodes
> flood these advertisements over the entire MANET network right?  Yuck!

There are lots of answers here, and it really depends on your assumptions.

1) Of course, you can unicast the advertisement back, according to whatever
   specification someone writes and gets standardized (or not!).

2) [manet] standards did not exist in 1996 (nor even 2002.45) so Mobile IP
   standards are not written for the convenience of mobile ad hoc networks.

3) Mobile IP agent advertisements are allowed to be unicast.

4) The router broadcasting the prefix advertisement DOES have to provide
   connectivity to the prefix it advertises, and NOT necessarily to
   any specific node within the manet that does not share the prefix.
   Ad hoc protocols can be viewed as creating host routes for cases
   where nodes do not share a common prefix, but by no means should
   preclude useful operation where nodes DO share a common prefix.

   In fact, you can autoconfigure care-of addresses to get global
   connectivity and all the other stuff you need, by careful address
   management and advertisement.  If you want a standard, then by
   all means pick a method (if you like ours, so much the better!)
   and push!

So, what exactly is your model and your need?

Regards,
Charlie P.

---

From: "Phil Neumiller" <[email-masked]>
Date: Thu, 30 May 2002 14:23:07 -0400

>    specification someone writes and gets standardized (or not!).

I guess I thought this might be an easy sell for the IESG to add into 3220 no?

>    standards are not written for the convenience of mobile ad hoc networks.

Yeah, I have really been noticing that a lot lately!!! :-)

> 3) Mobile IP agent advertisements are allowed to be unicast.

REALLY?  The ICMP router advertisment (Deering) does not allow them as
far as I can tell.  How do we configure this?  Is that the intent of RFC-3220? 
The spec seemed a bit foggy on this notion to me.  It would be really nice if
the RFC said something like:

the FA/HA MUST support a unicast response when the U bit is set in the 
solicitation message.

THIS IS WHAT I REALLY NEED!!!  (Sorry for shouting).

>    preclude useful operation where nodes DO share a common prefix.

Not really fully fledged host routes since we are still routing based on
next hop right?  I

> So, what exactly is your model and your need?

See above!

Thanks,

Phil

---

From: "Charles E. Perkins" <[email-masked]>
Date: Thu, 30 May 2002 14:10:39 -0700

Hello Phil,

> I guess I thought this might be an easy sell for the IESG to add into 3220 no?

I forgot when it was ever easy.  You should voice your concerns if
you want them to be attended.

> Yeah, I have really been noticing that a lot lately!!! :-)

I have noticed that when one mentions "manet" and "standards"
in the same sentence, people often have strange reactions.

> THIS IS WHAT I REALLY NEED!!!  (Sorry for shouting).

From RFC 3220, section 2.1, page 18...
===================================================================================

         Destination Address
   
               As specified for ICMP Router Discovery [10], the IP
               destination address of an multicast Agent Advertisement
               MUST be either the "all systems on this link" multicast
               address (224.0.0.1) [11] or the "limited broadcast"
               address (255.255.255.255).  The subnet-directed broadcast
               address of the form <prefix>.<-1> cannot be used since
               mobile nodes will not generally know the prefix of the
               foreign network.  When the Agent Advertisement is unicast
               to a mobile node, the IP home address of the mobile node
               SHOULD be used as the Destination Address.

===================================================================================

Is this good enough?

> next hop right?

A host route still only has to determine the next hop, not
the whole routing path.

>> So, what exactly is your model and your need?

Hmmm...  I still am not sure, though.  But if you say
this meeds the need, then O.K.!

Regards,
Charlie P.

---

From: "Phil Neumiller" <[email-masked]>
Date: Thu, 30 May 2002 17:57:55 -0400

Hi Charlie and thanks for the quick response.  I tried to keep this short, but... :-)
> From RFC 3220, section 2.1, page 18...

I don't know.  Maybe I am really confused but nobody has probably ever asked this question before
so let me try (then again how many commercial vendors are mixing MIP with MANETs :-)?

Assume the MN uses its home address to route on in its home MANET.  Now assume the mobile has
moved to a foreign MANET.  

NOTE: Subnet directed broadcasts are meaningless in a MANET unless you simulate them with a 
MANET flood.  

A periodic MANET flood could be used to do the FA advertisements to all MANET/MIP MNs
new and old that are "reachable" on the MANET (i.e. have converged routes).  

Now these reachable MNs MUST put the FA address in a periodic hello message.  So every MN
that is part of the MANET is advertising the FA via a hello message rather than having the FA do
more periodic MANET floods (which I believe to be much more expensive).  So the new MN (which
still only has its MIP home address) can see the FA address in a hello and decides to do a RREQ
to the FA.  Once this route has converged the MN can then perform a MIP FA COA binding to the HA.
[ BTW: This seems like a pretty ugly way to do a handover.]

Upon further reflection, I guess you can't really use solicitation at all in this case because you have to
have a route to/from the FA to begin with???  So my original question was probably bogus.

I realize that this seems like a ball of confusion and probably is but I think we are breaking new 
ground here.  Do you have a suggestion on how to make this work better?  In summary (whew!).

o  We can't use solicitations unless they are flooded across the MANET to reach the FA (bad 
     idea).
o  We can do periodic subnet directed broadcast agent advertisements from the FA, but these 
    will only reach the first hop around the FA without flooding.  It is then the responsibility of
    the first ring of nodes to start advertising the FA address in periodic hello messages and this
    propogates through the whole MANET.  It is further more the responsibility of MNs hearing
    the FA advertisement via AODV hello to start their own periodic agent advertisement.
o  New nodes entering the foreign subnets will start to hear these hello message agent advertisements
    and be able to do a RREQ and then a MIP handover.

I seem to be missing something critical here.

YUCK!

Phil

---

From: "Charles E. Perkins" <[email-masked]>
Date: Thu, 30 May 2002 15:10:24 -0700

Hello Phil,

Phil Neumiller wrote:

> o  We can't use solicitations unless they are flooded across the MANET to reach
>    the FA (bad idea).
> o  We can do periodic subnet directed broadcast agent advertisements from the
>    FA, but these will only reach the first hop around the FA without flooding.
>    It is then the responsibility of the first ring of nodes to start advertising
>    the FA address in periodic hello messages and this propogates through the
>    whole MANET.  It is further more the responsibility of MNs hearing the FA
>    advertisement via AODV hello to start their own periodic agent advertisement.
> o  New nodes entering the foreign subnets will start to hear these hello message
>    agent advertisements and be able to do a RREQ and then a MIP handover.

What do you think about the following drafts?
	draft-royer-manet-globalv4-00.txt
	draft-wakikawa-manet-globalv6-00.txt
	draft-perkins-manet-autoconf-01.txt

These have been implemented and tested.  Updates are
needed, but the basic ideas are there.

It's not quite a trivial problem, and it's even
more fun if you have multiple access routers/
foreign agents.

Regards,
Charlie P.

---

From: "Phil Neumiller" <[email-masked]>
Date: Thu, 30 May 2002 18:16:48 -0400

I believe I commented on some of these before.  I will take a new
look at globalv4. BTW is this your answer to the NEMO problem?